# Release Candidate of Canton 1.0.0-rc6

Canton 1.0.0-rc6 has been published on 2022-01-10.

## Minor Improvements

- Including last errors in the health.dump
- Consolidated all timeout arguments in the console commands to use the same argument type `TimeoutDuration`, including a default translation from `scala.concurrent.duration.Duration`. This means that all timeouts are now to be defined as `x.millis`, `x.seconds` or `x.minutes`. Usually this is not necessary as the default arguments should suffice.
- Fixed a minor issue where the console help did not include the domain manager and setup commands.
- Extended the sequencer node to expose the topology read service, allowing inspecting the topology state of a sequencer node for troubleshooting purposes.
- Fixed the database initialisation to avoid allocating an unnecessary database connection pool temporarily during startup.
- Fixed an issue where an exception was thrown on a startup failure, leading to unnecessary noise on the console.
- Reworked and clarified on how many db connections are allocated when explicitly setting the db connection numbers with max-db-connections.
- Improved idempotency of domain bootstrapping command.
- Improved logging clarify when hitting database overload situations.
- Enabled tracing propagation by default.
